; PIC orgel

F683	=	1
V12	=	1

	ifdef	F819
	list	p=16f819
	include	p16f819.inc
	errorlevel	-302
	__CONFIG   _CP_OFF & _WRT_ENABLE_OFF & _CPD_OFF & _CCP1_RB2 & _DEBUG_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _WDT_OFF & _PWRTE_ON & _HS_OSC
SCL	=	0
SDA	=	1
GPIO	=	PORTA
TRISIO	=	TRISA
	endif
	ifdef	F683
	list	p=12f683
	include	p12f683.inc
	errorlevel	-302
	__CONFIG   _FCMEN_OFF & _IESO_OFF & _BOD_OFF & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF & _HS_OSC
SDA	=	0
SCL	=	1
	endif
IICADR	=	0xa0
	cblock	0x20
	v0v
	v0dl
	v0dh
	v0tl
	v0th
	datal
	datah
	tmp
	v1v
	v1dl
	v1dh
	v1tl
	v1th
	v1p0
	v1p1
	v1p2
	v2v
	v2dl
	v2dh
	v2tl
	v2th
	v2p0
	v2p1
	v2p2
	v3v
	v3dl
	v3dh
	v3tl
	v3th
	v3p0
	v3p1
	v3p2
	v4v
	v4dl
	v4dh
	v4tl
	v4th
	v4p0
	v4p1
	v4p2
	v5v
	v5dl
	v5dh
	v5tl
	v5th
	v5p0
	v5p1
	v5p2
	v6v
	v6dl
	v6dh
	v6tl
	v6th
	v6p0
	v6p1
	v6p2
	v7v
	v7dl
	v7dh
	v7tl
	v7th
	v7p0
	v7p1
	v7p2
	v8v
	v8dl
	v8dh
	v8tl
	v8th
	v8p0
	v8p1
	v8p2
	v9v
	v9dl
	v9dh
	v9tl
	v9th
	v9p0
	v9p1
	v9p2
	vav
	vadl
	vadh
	vatl
	vath
	vap0
	vap1
	vap2
	vbv
	vbdl
	vbdh
	vbtl
	vbth
    endc
	cblock	0xa0
	iicdata
	contflag
	endc
;
	org	0
	goto	start
	org	4
	retfie
start:
	ifdef	F819
	movlw	0
	banksel	PORTA
	movwf	PORTA
	movwf	PORTB
	movlw	6
	banksel	ADCON1
	movwf	ADCON1
	movlw	0xff
	banksel	TRISA
	movwf	TRISA
	movlw	0
	movwf	TRISB
	endif
	ifdef	F683
	movlw	0
	banksel	GPIO
	movwf	GPIO
	movlw	7
	banksel	CMCON0
	movwf	CMCON0
	movlw	0
	banksel	ANSEL
	movwf	ANSEL
	movlw	0xfb
	banksel	TRISIO
	movwf	TRISIO
	endif
	if	V12
	movlw	0x96		; 33113Hz
	else
	movlw	0x6a		; 46729Hz
	endif
	banksel	PR2
	movwf	PR2
	movlw	4
	banksel	T2CON
	movwf	T2CON
	ifdef	F819
	banksel	EECON1
	bcf	EECON1,EEPGD
	endif
;
	banksel	v0v
	clrf	v0v
	clrf	v1v
	clrf	v2v
	clrf	v3v
	clrf	v4v
	clrf	v5v
	clrf	v6v
	clrf	v7v
	clrf	v8v
	clrf	v9v
	clrf	vav
	clrf	vbv
	banksel	contflag
	clrf	contflag
; set read address to 0
	banksel	TRISIO
	bcf	TRISIO,SDA		; start condition
	movlw	IICADR
	movwf	iicdata
	call	send1
	clrf	iicdata
	call	send1
	call	send1
	bsf	TRISIO,SCL
; fall
mainloop:
	banksel	TRISIO
	btfsc	contflag,0
	goto	l1
	bsf	contflag,0
	bcf	TRISIO,SDA		; start condition
	movlw	IICADR+1
	movwf	iicdata
	call	send1
	goto	recv2
l1:
	bcf	TRISIO,SDA		; ACK
	bsf	TRISIO,SCL
	nop
	bcf	TRISIO,SCL
	bsf	TRISIO,SDA
; fall
recv2:
	bsf	TRISIO,SDA
;
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	goto	recv_wait
	banksel	TRISIO
	bcf	TRISIO,SCL
	clrf	FSR
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	FSR,6
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	FSR,5
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	FSR,4
	banksel	TRISIO
	bcf	TRISIO,SCL
	movlw	0x20	;start of v0
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	FSR,3
	banksel	TRISIO
	bcf	TRISIO,SCL
	addwf	FSR,f
	clrf	INDF
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	INDF,3
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	INDF,2
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	INDF,1
	banksel	TRISIO
	bcf	TRISIO,SCL
;
	bcf	TRISIO,SDA		; ACK
	bsf	TRISIO,SCL
	banksel	tmp
	clrf	tmp
	banksel	TRISIO
	bcf	TRISIO,SCL
	bsf	TRISIO,SDA
;
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	INDF,0
	banksel	TRISIO
	bcf	TRISIO,SCL
	incf	FSR,f
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	tmp,7
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	tmp,6
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	tmp,5
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	tmp,4
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	tmp,3
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	tmp,2
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	tmp,1
	banksel	TRISIO
	bcf	TRISIO,SCL
;
	banksel	tmp
	movf	tmp,w
	banksel	EEADR
	movwf	EEADR
	ifdef	F819
	banksel	EECON1
	endif
	bsf	EECON1,RD
	ifdef	F819
	banksel	EEDATA
	endif
	movf	EEDATA,w
	movwf	INDF
	incf	FSR,f
	ifdef	F819
	banksel	EEADR
	endif
	incf	EEADR,f
	ifdef	F819
	banksel	EECON1
	endif
	bsf	EECON1,RD
	ifdef	F819
	banksel	EEDATA
	endif
	movf	EEDATA,w
	movwf	INDF
	incf	FSR,f
	movlw	0xff
	movwf	INDF
	incf	FSR,f
	movwf	INDF
	goto	mainloop

recv_wait:
	clrf	datal
	clrf	datah
	bsf	datah,7
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datah,6
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datah,5
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datah,4
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datah,3
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datah,2
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datah,1
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datah,0
	banksel	TRISIO
	bcf	TRISIO,SCL
;
	bcf	TRISIO,SDA		; ACK
	bsf	TRISIO,SCL
	nop
	bcf	TRISIO,SCL
	bsf	TRISIO,SDA
;
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datal,7
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datal,6
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datal,5
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datal,4
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datal,3
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datal,2
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datal,1
	banksel	TRISIO
	bcf	TRISIO,SCL
	nop
	bsf	TRISIO,SCL
	banksel	GPIO
	btfsc	GPIO,SDA
	bsf	datal,0
	banksel	TRISIO
	bcf	TRISIO,SCL
;
	nop
	bsf	TRISIO,SCL		; returns NAK (SDA is not driven)
	bcf	contflag,0
	bcf	TRISIO,SCL
	bcf	TRISIO,SDA
	bsf	TRISIO,SCL
	bsf	TRISIO,SDA		; stop condition
; generate tone
	banksel	GPIO
l2:
	if	V12
	btfss	TMR2,7
	else
	btfss	TMR2,6
	endif
	goto	l2
l3:
	movf	v0dl,w
	addwf	v0tl,f
	movf	v0dh,w
	btfsc	STATUS,C
	addlw	1
	addwf	v0th,f
	movf	v0v,w
	btfsc	STATUS,C
	sublw	0
	movwf	v0v
	movf	v1dl,w
	addwf	v1tl,f
	movf	v1dh,w
	btfsc	STATUS,C
	addlw	1
	addwf	v1th,f
	movf	v1v,w
	btfsc	STATUS,C
	sublw	0
	movwf	v1v
	movf	v2dl,w
	addwf	v2tl,f
	movf	v2dh,w
	btfsc	STATUS,C
	addlw	1
	addwf	v2th,f
	movf	v2v,w
	btfsc	STATUS,C
	sublw	0
	movwf	v2v
	movf	v3dl,w
	addwf	v3tl,f
	movf	v3dh,w
	btfsc	STATUS,C
	addlw	1
	addwf	v3th,f
	movf	v3v,w
	btfsc	STATUS,C
	sublw	0
	movwf	v3v
	movf	v4dl,w
	addwf	v4tl,f
	movf	v4dh,w
	btfsc	STATUS,C
	addlw	1
	addwf	v4th,f
	movf	v4v,w
	btfsc	STATUS,C
	sublw	0
	movwf	v4v
	movf	v5dl,w
	addwf	v5tl,f
	movf	v5dh,w
	btfsc	STATUS,C
	addlw	1
	addwf	v5th,f
	movf	v5v,w
	btfsc	STATUS,C
	sublw	0
	movwf	v5v
	movf	v6dl,w
	addwf	v6tl,f
	movf	v6dh,w
	btfsc	STATUS,C
	addlw	1
	addwf	v6th,f
	movf	v6v,w
	btfsc	STATUS,C
	sublw	0
	movwf	v6v
	movf	v7dl,w
	addwf	v7tl,f
	movf	v7dh,w
	btfsc	STATUS,C
	addlw	1
	addwf	v7th,f
	movf	v7v,w
	btfsc	STATUS,C
	sublw	0
	movwf	v7v
	if	V12
	movf	v8dl,w
	addwf	v8tl,f
	movf	v8dh,w
	btfsc	STATUS,C
	addlw	1
	addwf	v8th,f
	movf	v8v,w
	btfsc	STATUS,C
	sublw	0
	movwf	v8v
	movf	v9dl,w
	addwf	v9tl,f
	movf	v9dh,w
	btfsc	STATUS,C
	addlw	1
	addwf	v9th,f
	movf	v9v,w
	btfsc	STATUS,C
	sublw	0
	movwf	v9v
	movf	vadl,w
	addwf	vatl,f
	movf	vadh,w
	btfsc	STATUS,C
	addlw	1
	addwf	vath,f
	movf	vav,w
	btfsc	STATUS,C
	sublw	0
	movwf	vav
	movf	vbdl,w
	addwf	vbtl,f
	movf	vbdh,w
	btfsc	STATUS,C
	addlw	1
	addwf	vbth,f
	movf	vbv,w
	btfsc	STATUS,C
	sublw	0
	movwf	vbv
	endif
; make voice
	movlw	0x80
	addwf	v0v,w
	addwf	v1v,w
	addwf	v2v,w
	addwf	v3v,w
	addwf	v4v,w
	addwf	v5v,w
	addwf	v6v,w
	addwf	v7v,w
	if	V12
	movwf	tmp
	movlw	0x80
	addwf	v8v,w
	addwf	v9v,w
	addwf	vav,w
	addwf	vbv,w
	addwf	tmp,f
	else
	movwf	tmp
	bcf	STATUS,C
	endif
	rrf	tmp,f
	rrf	tmp,f
	movf	tmp,w
	andlw	0x7f
	movwf	CCPR1L
	rrf	tmp,f
	rrf	tmp,f
	rrf	tmp,w
	andlw	0x30
	iorlw	0xc
	movwf	CCP1CON
; length
	incfsz	datal,f
	goto	l4
	incfsz	datah,f
	goto	l3
	goto	mainloop
l4:
	goto	l3

send1:
	bcf	TRISIO,SCL
	bcf	TRISIO,SDA
	btfsc	iicdata,7
	bsf	TRISIO,SDA
	bsf	TRISIO,SCL
	nop
	bcf	TRISIO,SCL
	bcf	TRISIO,SDA
	btfsc	iicdata,6
	bsf	TRISIO,SDA
	bsf	TRISIO,SCL
	nop
	bcf	TRISIO,SCL
	bcf	TRISIO,SDA
	btfsc	iicdata,5
	bsf	TRISIO,SDA
	bsf	TRISIO,SCL
	nop
	bcf	TRISIO,SCL
	bcf	TRISIO,SDA
	btfsc	iicdata,4
	bsf	TRISIO,SDA
	bsf	TRISIO,SCL
	nop
	bcf	TRISIO,SCL
	bcf	TRISIO,SDA
	btfsc	iicdata,3
	bsf	TRISIO,SDA
	bsf	TRISIO,SCL
	nop
	bcf	TRISIO,SCL
	bcf	TRISIO,SDA
	btfsc	iicdata,2
	bsf	TRISIO,SDA
	bsf	TRISIO,SCL
	nop
	bcf	TRISIO,SCL
	bcf	TRISIO,SDA
	btfsc	iicdata,1
	bsf	TRISIO,SDA
	bsf	TRISIO,SCL
	nop
	bcf	TRISIO,SCL
	bcf	TRISIO,SDA
	btfsc	iicdata,0
	bsf	TRISIO,SDA
	bsf	TRISIO,SCL
	nop
;
	bcf	TRISIO,SCL
	bsf	TRISIO,SDA
	bsf	TRISIO,SCL
	nop
	bcf	TRISIO,SCL
	return

	org	0x2100
	include	table.asm

	end

